/* $Id: CHANGELOG,v 1.40.2.271 2006/06/19 15:42:55 ignatius0815 Exp $ */

********************************************************************************
*                            phpCMS 1.2.2                                      *
********************************************************************************

June 19, 2006 (iggi)
  * Updated phpCMS version number in sourcecode to 1.2.2
  * Updated the german "NEUE_FEATURES" page
  * Updated the upgrade readme files

June 18, 2006 (iggi)
  * Security enhancement: Prevent phpCMS from overwriting already registered
    global variables
  * Security enhancement: Protect include files from direct execution
  * Added possibility to use .PREACTIVE / .POSTACTIVE subtemplates in
    menu templates (thanks to wulmer for idea & patch!)
  * Added new edittype for online editor (creates a drop down selector in
    online edit mode):
    {SOMEFIELD EDITTYPE="SELECT" OPTIONS="option 1;option 2;option 3;option 4"}
    (thanks to DOC for the idea & patch!)
  * Fixed bug #1465677: $_REQUEST is now updated with parameters from {SCRIPTxxxx}
  * Changed default values for CONTENT_TOC and CONTENT_SEARCH in default.php
    from 'on' to 'off'
  * Updated the english "NEW_FEATURES" page

January 8, 2006 (guan)
  * Bugfix: Found and repaired the problem Samson mentioned in
    http://phpcms.de/forum/index.en.html?topic=6025.0 (Tags in one line are
    interpreted in the wrong order) - this was just a case of 'too early recursion'

January 7, 2006 (mjahn)
  * little error in checking a variable for existance in class.edit_phpcms.php
  * prepared htmlentities replacement for different charsets
    - created helper function in class.parser_phpcms.php
    - replaced all necessary htmlentities-calls with the helper-function
  * fixed bug #1396869
    - the phpCMS-tags will be not replaced in the editor-text-fields
      (phpcms:noindex, phpcms:ignore, phpcms:nofollow, $lang)
    - so they will not be deleted by the editor

January 6, 2006 (mjahn)
  * fixed bug with menu-engine (class.parser_template_phpcms.php)
    - the menu-templates for a menu will always output the .PRE and the .PAST
      fields of the menu-template, also if there are no entries in the menu
    - introduced new parameter IFNOTEMPTY to the menu-field in templates
      it supresses the output of the menu-template in this cases
  * fixed XHTML-error in editor-interface  (class.parser_template_phpcms.php)
    - added slashes before the closing brakets of "input" elements
    - added some comments for future bugfixes
  * fixed bug #689707 (class.parser_menu_phpcms.php)
    - the project-file now must not contain MENUTEMPLATE-definition
  * integrated features in online-editor
    - the edit-buttons are now disabled if the file is not writeable and the
      changes could not be saved secure
  * integrated a new interface for the online-editor (class.edit_phpcms.php)
    - in class.edit_backup_phpcms.php you can backup a contentfile, before the
      new content will be saved in it
  * fixed bug #1228075 (class.parser_template_phpcms.php)
    - .BETWEEN field will not be ignored if first line in the field is empty
    - until now the system only uses the first line in the .BETWEEN-field
  * fixed a bug with I18N in online-editor (parser.php)
    - the I18N-object was not initiated if the online-editor is active

October 26, 2005 (guan)
  * Rewrote / updated class.pax_phpcms.php:
    - Fixed 'basic' tags not being replaced in PAXTAG results

April 14, 2005 (mjahn)
  * fixed bug #1182794 in lib.log_referrer_phpcms.php

April 1, 2005 (mjahn)
  * integrated RewriteRules for installation in subdirectory

March 30, 2005 (mjahn)
  * integrated bugfix from bjmg for bug in caching system
    (see http://phpcms.de/forum/index.de.html?topic=5763.0)

February 23, 2005 (mjahn)
  * fixed a little bug with variables and SCRIPTs

February 03, 2005 (mjahn)
  * fixed a little but essential typo in default.php
  * refined the detection of CONTENT_TOC and CONTENT_SEARCH

December 07, 2004 (mjahn)
  * fixed a little typo-bug, that prevents the indexer from excluding file with
    a specified pattern (http://phpcms.de/forum/index.de.html?topic=5615)

November 29, 2004 (mjahn)
  * fixed bug #1075258: globalizing SCRIPT-parameters
  * fixed bug #1075257: corrected plugin-detection
  * included patch for global variable $lang (I18N)
  * included patch for using one tpl for TOC, search and content

********************************************************************************
*                            phpCMS 1.2.1pl1                                   *
********************************************************************************

November 25 2004 (bjmg)
  * fixed a XSS bug
    (only exploitable in non-stealth mode with debug mode enabled)

********************************************************************************
*                             phpCMS 1.2.1                                     *
********************************************************************************

October 22 2004 (bjmg)
  * merged Martin's bugfixes with branch-1_2 (for next release 1.2.1)

October 13 2004 (mjahn)
  * fixed bug #754917 (notices in filemanager)
  * fixed bug #805042 (error-messages, if M2C-image has incorrect path)
  * fixed bug #995525 (contentplugins get lost when using OE)
  * fixed bug #1017886 (spider and https-links / links to the same page)
  * fixed bug #1028411 (corrected setting of working directory in filemanager)
  * fixed bug #1046154 (call-time-pass-by-reference) in class.phpcms.php

September 22 2004 (mjahn)
 * implemented patch #1032686 with includepath

August 30, 2004 (bjmg)
 * Corrected a small error in demo-en (wrong link to edit help)

August 28, 2004 (bjmg)
 * changed version number in default.php too

August 27, 2004 (Susanne, Harald, bjmg)
 * new english version of our demo (Harald)
   - renamed it to demo-en
 * changed german version of our demo (Harald)
   - renamed it to demo-de
 * changed license text - new date 2004
 * changed install instructions to (1.2.0 -> 1.2.x)
 * changed the logo in the GUI
 * included the new logos into the archive (Susanne)
 * added new <LOGO*> tags - new logos are shown
   <LOGO_S_G>, <LOGO_B_G>,
   <LOGO3D_S_W>, <LOGO3D_B_W>,
   <LOGO3D_S_G>, <LOGO3D_B_G>,
   <LOGO3D_S_B>, <LOGO3D_B_B>
 * changed the urls to the demos in /parser/help/*
 * added the url of the new demo in /parser/help/*
 * changed TITEL into TITLE to reflect changes in demo-*
 * changed path to demo in file indexer
 * reindexed demo-en and demo-de with file indexer
 * changed version number to 1.2.1

August 24, 2004 (bjmg)
 * ERROR_ALL is off by default - again

August 20, 2004 (bjmg)
 * fixed a small bug. There was a 5 before the XHTML header in the HTTP indexer
 * corrected a bug in default.php I introduced 2 days ago

August 18, 2004 (bjmg)
 * added patch #947175 variable delimiter in tags (submitted by samson1964)
 * added patch #777266 variable delimiter in menu-parser (submitted by otaku)
   - both variants are possible: using the DELIMITER: command in the menu file
     or by changing the default delimiter in default.php
 * added the missing default.php entries to class.setup_phpcms.php
 * added entries to configuration editor
 * edded entries to options.*.htm(l)
 * added patch #768554 .BETWEEN in menu template (submitted by ktauber)
 * added a similar patch to the sitemap component (TOC.*.BETWEEN)

August 17, 2004 (bjmg)
 * removed a notice in class.options_phpcms.php when phpCMS in ERROR_ALL mode
 * optimized the rendering process of PAXMENU a little bit
 * added FTP and HTTPS to ChangeHREF (class.parser_phpcms.php) this fixes a bug
   that is only present in non-stealth mode when you link a ftp/https-site.
 * fixed bug #984947 image files +/ MIME types
   - changed text/js to application/x-javascript
   - added the extensions .jpeg and .jpe
 * changed version number to 1.2.1 CVS
 * fixed bug #920455 Call to PHP->getScriptPath()
 * fixed bug #754917 Two messages in filemanager with E_ALL
   - fixed only the bug in line 595

********************************************************************************
*                             phpCMS 1.2.0                                     *
********************************************************************************

August 08, 2004 (bjmg)
 * changed forum urls in readme
 * corrected some installation hints (execution rights are not needed)
 * added a KNOWNBUGS file

July 16, 2004 (bjmg)
 * prepare for relase 1.2.0 final
 * deleted BETA messages

May 31 2004 (mjahn)
 * fixed little notice with undefined variable in class.realtime_phpcms.php

May 29 2004 (mjahn)
 * fixed bug with PAXCOMBOBOX (http://phpcms.de/forum/showthread.php?id=5117)

Feb 21 2004 (mjahn)
 * fixed bug #900346 with missing parameters in SCRIPT-field
 * fixed a warning, when the PROJECT-field is missing (class.parser_page..)

Feb 07 2004 (beate76)
 * made end_edit.tpl xhtml-compatible

Jan 11 2004 (mjahn)
 * fixed bug 871957: missing first URI-parameter in $_GET_POST

Dec 07 2003 (beate76)
 * inserted a label in filemanager for better accesibility in move/rename files

Dec 05 2003 (tobiasd)
* fixed typo in parser.php (check for edit mode) and class.edit_phpcms.php
  (set initial cookies)

Dec 03 2003 (mjahn)
 * fixed bug with wrong mail2crypt-adress in konqueror

Nov 27 2003 (tobiasd)
 * fixed bug in referrer logging (no new referrer entries were added when
   $DEFAULTS->STATS_REFERER_COUNT was reached)
 * beautified and optimized syntax for stat/referrer logging

Nov 23 2003 (tobiasd)
 * shell indexer: fixed typo 'found'->'$found' (including language file)

Nov 16 2003 (tobiasd)
 * fixed notice message in class.cache_phpcms.php, lib.log_referrer_phpcms.php
 * fixed wrong 'Last-Modified' header when using client cache

Nov 15 2003 (tobiasd)
 * fixed possible bug in class PHPCMS (btw: phpCMS works with PHP 5.0 beta 2)
 * parser/.htaccess: - comment out 'Options -Indexes'
                    - add commented out (security) settings
 * fixed notice message in class.parser_template_phpcms.php (menu code)

Nov 11 2003 (ignatius0815)
 * fixed bug 770929: Errormessage in Online-Editor when file is missing
 * fixed bug 822767: HTTP-Indexer indexes more then he should
 * modified an errormessage in class.lib_indexer_profile_phpcms.php

Nov 10 2003 (ignatius0815)
 * fixed bug 825424: Wrong "previous" button in statistics
 * fixed bug 825422: Hardcoded english langage in statistics
 * improved navigation in statistics module

Nov 09 2003 (tobiasd)
 * fixed warnings and notices in debug tool
 * fixed bugs and warnings with PHP < 4.1.0 (in combination with the superglobal
   variables introduced in PHP 4.1.0)

Oct 19 2003 (tobiasd)
 * deactivated directory listing in parser directory-tree via .htaccess
 * deactivated web access to plugin directory (.htaccess, also added index.html)
 * Mail2Crypt: faster search for closing head tag (use strpos not strstr)
 * Mail2Crypt: added (undocumented) setting for automatic/manual inclusion of
   the external JS file

Oct 13 2003 (ignatius0815)
 * replaced hardcoded "upgrade available" text in class.layout_phpcms.php by
   strings from the language file and slightly modified the text-color of
   the update-message

********************************************************************************
*                           phpCMS 1.2.0 RC1                                   *
********************************************************************************

Oct 08 2003 (mjahn)
 * fixed bug with false interpretation of SCIPT-fields with '?&param=value'
   instead of '?param=value' when server-cache is on (http://phpcms.de/forum/
   showthread.php?id=4510)

Oct 08 2003 (tobiasd)
 * adjusted error_reporting settings (now depend on $DEFAULTS->DEBUG and
   $DEFAULTS->ERROR_ALL)

Oct 08 2003 (ignatius0815)
 * updated fix for bug #816536: Warning in parser.php when $REQUEST_URI
   doesn't exist
 * changed default error reporting to "E_ALL ^ E_NOTICE"
 * fixed a bug in shell_indexer.php (class.lib_indexer_universal_phpcms.php
   depends on data from the language file but the language file wasn't included
   in the shell indexer)

Oct 06 2003 (ignatius0815)
 * class.search_indexer_phpcms.php:
    - reformated sourcecode and corrected some typos in the comments
    - renamed array 'redyarray' to 'readyarray'
    - fixed bug 818561: file indexer can't handle long START_FIELD delimeters
 * fixed bug #758831: HTTP-Indexer strips punctuation marks
 * introduced new option $DEFAULTS->ERROR_ALL to switch error-reporting to
   "all"

Oct 05 2003 (tobiasd)
 * shell indexer, session file class: don't delete index.html in directories
 * parser.php: corrected error_reporting settings, set level without debug mode
 * plugin counter.php: changed comments (translated to english),only output
   number, not complete (German) string

Oct 02 2003 (beate76)
 * fixed bug: missing ">" in class.parser_file_phpcms.php in regex
   "phpcms:nofollow"
 * fixed bug #816536: Warning in parser.php when $REQUEST_URI doesn't exist
 * fixed bug: topref-plugin doesn't show last last referer on
   $show_duration=false

Sep 14 2003 (beate76)
 * demo site: changed form-hidden-field phpcms_recourd_count into phpcms_rc

Sep 03 2003 (beate76)
 * included oarsman's pics (logout, reload) in GUI

Sep 01 2003 (ignatius0815)
 * fixed bug #759673: <QUERY_TERM> doesn't work in 1.2.0beta2

Aug 31 2003 (ignatius0815)
 * fixed bug #781471: <phpcms:ignore> and <phpcms:nofollow> only worked if
                      start- and end-tag was in the same template
 * fixed bug #786236: problems with backslashes when php is run as CGI under
                      Microsoft IIS (fix from "e157m369")
 * enhanced class.lib_phpcms.php (fixes bug #781512)
    - Added some debugging functionalties (change var _debug in class LibphpCMS
      to 'true' to output debug messages)
    - Using pre-defined php constant 'PHP_OS' to determine the operating
      system php is running under
 * prepared class.parser_template_phpcms.php to work with a WYSIWYG Online
   Editor which can be plugged into the OE system by placing an aditional
   file class.edit_wysiwyg_phpcms.php into the include directory

Aug 11 2003 (beate76)
 * inserted a nearly blank html-page in folders with no access (for IIS,
   who can't interprete .htaccess)
 * expanded the JS-replacement of </head> also to </HEAD>
   (see http://phpcms.de/forum/showthread.php?id=4298)

Aug 06 2003 (tobiasd)
 * rename test.php to tag.php (as it was before)
 * added (more) workarounds for potential bugs with PHP problem in is_array

Aug 04 2003 (mjahn)
 * fixed bug: caching does not work

Aug 01 2003 (tobiasd)
 * reset global arrays after foreach in class.phpcms.php
 * fixed bug #781546: Mail2Crypt doesn't work in online editor mode
 * removed <-- MAIL2CRYPT include --> from demo/index.htm (not needed anymore)
 * fixed bug in Mail2Crypt (doesn't replaced Mail2Crypt block when outdated
   <-- MAIL2CRYPT include --> was in same line)

Aug 01 2003 (bjmg)
 * changed version to RC1 (first release candidate)

Jul 27 2003 (ignatius0815)
 * fixed bug: PLUGIN and SCRIPT calls in templates produced blank lines in
   html output (related to task #72290)

Jul 23 2003 (tobiasd)
 * fixed bug #775911: Included TopRef-Plugin shows always top referrer table

Jul 12 2003 (tobiasd)
 * doc: corrected description for the plugin example, changed plugin tags
 * fixed bug #770094: Debug tool is always active

Jul 02 2003 (tobiasd)
 * deleted empty lines after php end-tag

Jun 27 2003 (zeekjt)
 * demo: fixed phpinfo box on bottom (was entirely black with PHP > 4.3.0)

Jun 25 2003 (ignatius0815)
 * improved function getOS in class.lib_phpcms.php

Jun 21 2003 (mcyra)
 * revoke fix with content length in gzip class

Jun 21 2003 (tobiasd)
 * changed login hash from crypt to md5 (GUI, Debug Tool, Online Editor)
 * renamed shell indexer file from phpcms_shell_indexer.php to shell_indexer.php
 * renamed test plugin file from tag.php to test.php

********************************************************************************
*                           phpCMS 1.2.0 Beta2                                 *
********************************************************************************

Jun 15 2003 (tobiasd)
 * fixed typo in german .htaccess sample
 * added note for windows explorer rename bug to .htaccess sample files

Jun 15 2003 (hpoe)
 * added upgrade instructions
 * HTTP-Indexer:
   - fixed some CSS issues
   - introduced <phpcms:nofollow> ... </phpcms:nofollow> tag.
     Links enclosed in nofollow tags will not be spidered by the indexer.
   - fixed broken error handling for files that return Error 07
 * updated demo full text index

Jun 14 2003 (hpoe)
 * fixed link on "No passwort set" screen
 * fixed typo in sample.htaccess and beispiel.htaccess

Jun 14 2003 (mjahn)
 * Cache-GUI
    - fixed bug with long filenames (#754147)

Jun 13 2003 (hpoe)
 * fixed bug #727444 Errormessage in HTTP-Indexer when wrong file permissions
    (actually, this is not an indexer bug but an issue that pertains to
    phpCMS's session class.
    The fix is in class.lib_session_file_phpcms.php)
 * fixed issue with empty delimiter in strpos in
   class.lib_indexer_universal_phpcms.php

Jun 12 2003 (hpoe)
 * HTTP-Indexer
    - fixed bug #753007 HTTP-Indexer - search rank icon does not display
    - fixed bug #753285 HTTP-Indexer chokes on extension-less files
    - fixed bug #687547 http-indexer und "Spidervorgang 0 Dateien"
    - fixed bug #732185 phpcms:noindex tag not working
    - integrated HTTP-Indexer with GUI.
      The HTTP-Indexer now no longer opens outside of the GUI.
      As a consequence of this it can no longer be used standalone.
    - replaced stristr() with -faster- strpos() wherever possible
    - text in between <noscript> tags is now ommitted
      (this keeps ASCII encoded e-mail addresses out of the index)
 * File-Indexer
    - clean out old log file

Jun 10 2003 (hpoe)
 * inline manual:
    - added CSS to inline manual
    - split doc.tpl into doc.en.tpl and doc.de.tpl
    - added "built-in functions" to inline manual
    - merged "templates" and "sub-templates" in English inline manual
    - removed PAX MailCrypt from PAX description
 * added commented .htaccess files (sample.htaccess and beispiel.htaccess)

Jun 10 2003 (tobiasd)
 * fixed some small errors with variable mapping when using PHP 4.0.6

Jun 09 2003 (beate76)
 * cleaning up documentation under /parser/doc/doc_de/

Jun 08 2003 (beate76)
 * corrected some typos in plugin-entwicklung.txt, liesmich.txt and editor.txt

Jun 08 2003 (hpoe)
 * fixed bug #747319: File-Indexer deletes ALL files in data directory
 * fixed bug #745989: PHPCMS CONTENT STOP not working in HTTP-Indexer
 * fixed bug #748753: problems with missing action parameter in forms (in
   non-stealth mode)
 * class.parser_phpcms.php:
    - fixed bug #750796: Non-Stealth Mode: CSS URL-rewrite too strict
    - some code/performance optimization

Jun 05 2003 (hpoe)
 * fixed bug #748746 "wrong link to options-helpfile in config screen"
 * class.mail2crypt_phpcms.php: fixed formatting of JS output in error message

Jun 04 2003 (beate76)
 * added workaround for the fouc-problem in the demo

Jun 03 2003 (tobiasd)
 * changed comment in .htaccess files

Jun 02 2003 (tobiasd)
 * class.options, class.realtime: two small E_ALL bugfixes
 * some formatting in CHANGELOG
 * updated NEW_FEATURES
 * removed orphan files help/options_[de|en].[htm|html]
 * added SSL support (except HTTP Indexer!)
 * improved domain name recognition when HTTP server not running on port 80

Jun 01 2003 (mjahn)
 * corrected a little typo in language.de

May 30 2003 (wulmer)
 * class.parser_page_phpcms.php: fixed bug #746234 (template parameter
   was not recognized if not at the end of query string)

May 30 2003 (mcyra)
 * class.parser_phpcms.php: fixed bug #745759 spaces in tags with vars are
   possible now.
 * class.parser_template_phpcms.php: fixed bug #744935 (menuentry)

May 30 2003 (hpoe)
 * moved code to write statistics and referrer log to separate files:
    - lib.log_stats_phpcms.php and
    - lib.log_referrer_phpcms.php
    These files are being included not in class.cache_phpcms.php but in
    parser.php so that e.g. an attempt to breach secure stealth mode is
    visible in the statistics

May 29 2003 (tobiasd)
 * class.phpcms.php: next attempt to fix the bug with the brackets (see May 21)

May 28 2003 (mcyra)
 * class.lib_indexer_profile_phpcms.php: fixed bug #731461 (foreach)

May 28 2003 (mcyra)
 * phpcms_shell_indexer.php: fixed bug #744937 (memory-allocation)
 * re-integrate logging with shell_indexer.

May 27 2003 (tobiasd)
 * demo site: PAXPHP in tag file, $DEFAULTS->DOCUMENT_ROOT not $PHP->GetDocRoot

May 27 2003 (hpoe)
 * class.lib_phpcms.php: rewrote path extraction logic
    - added function GetPaths();

May 26 2003 (hpoe)
 * class.options_phpcms.php:
    - added title attribute "view usage notes" to links in options.en.html
    - added a{text-decoration:none} to Configuration
    - cleaned out some left-over code in function WriteOptionLine
 * removed JS include from options.en.html

May 25 2003 (mcyra)
 * fixed SAPI/OS - bug in class.lib_phpcms.php: return after setting SAPI/OS

May 24 2003 (hpoe)
 * suggested bug fix for #742646 referrer log data corruption
   (class.cache_phpcms.php and topref.php)
 * unset() referrer array to reduce memory footprint

 * fixed link to options.en/de.htm in function WriteInputLine()
   in class.stat_phpcms.php
 * renamed GUI help text files from options_en.html to options.en.html
 * added, edited, and reformatted GUI help text entries
   (#734780 GUI help messages incomplete)

 * File-Indexer and search:
    - fixed bug #738558: docroot not accepted as start path
      (in function unslash_dir())
    - fixed bug #703884: Local stop.db not recognized
    - added message to screen that is displayed when default.php is
      incompatible, informing users of need to convert their stop word and word
      index files to lowercase.
    - made title field name, content field name, and additional field names
      configurable in GUI (added function addIndexField())
    - fixed bug in function optimize_stopdb()

  * spell checked message files (language.en/.de)

May 21 2003 (tobiasd)
 * fixed small bug in class.phpcms: bracket at wrong position

May 20 2003 (tobiasd)
 * several E_ALL bugfixes (GUI)
 * small change in error handling: $errnr in $DEFAULTS->ERROR_PAGE is now
   replaced by the phpCMS error number
 * test page for topref plugin: corrected path to plugin

May 18 2003 (tobiasd)
 * strip leading 'www.' for creating cache-filename
   -> avoid duplicate files in server cache
 * corrected E_ALL bugfixes from May 16
 * Filemanager:
   - use $_FILES not $_REQUEST for uploaded file (due to a change in PHP 4.3.0)
   - fixed some error messages with PHP 4.3.0 (W2k) and open_basedir
     (when open_basedir==DOCUMENT_ROOT and DOCUMENT_ROOT is shown in the FM)
   - fixed bug #739430: Dir size in FM wrong
     (that wasn't a bug, so it's now a new feature ;-)

May 17 2003 (tobiasd)
 * fixed very small bug in FM (space between icons in cache view)

May 16 2003 (tobiasd)
 * PAX, OE, sitemap etc: Fixed notice messages when error_reporting set to E_ALL
 * fixed bug #738802: $MESSAGES[50] missing

May 15 2003 (tobiasd)
 * file manager: fixed bug #735333: File upload broken
 * HTTP indexer (class.indexer_universal... and phpcms_shell_indexer...)
   - fixed bug #667882: Error with relative paths containing ..
   - shell indexer: profile can now be specified by the profile number
   - reformatted the code, translated some comments
 * fixed bug #738427: Nicht XHTML konforme Ausgabe in class.session_phpcms.php

************************************************
* Renamed branch - Merged branch-1_2 with HEAD *
************************************************

May 11 2003 (hpoe)
 * class Mail2Crypt:
    - rewrote <noscript> display logic
    - fixed potential problem when paths are set w/o trailing slash
    - improved speed by limiting redundant execution of code
    - changed logic for inclusion of JS file:
      both <!-- MAIL2CRYPT include --> and <!-- MAIL2CRYPT embed -->
      are now obsolete.
      <script> tag for inclusion of JS file is now injected into <head> only
      if a MAIL2CRYPT tag is present in a page

May 10 2003 (beate76)
 * proposed fix for bug #734710: 2 Bugs in class.mail2crypt_phpcms.php
   (thx to constabel)

May 08 2003 (hpoe)
 * fixed bug #733708: wrong link color in CSS for GUI

May 07 2003 (Ignatius0815)
 * changed all version numbers from beta1 to beta2

May 07 2003 (mcyra)
 * added menu handling for parameters in URLs in
   class.parser_template_phpcms.php
   (see http://phpcms.de/forum/showthread.php?id=3725)

May 07 2003 (hpoe)
 * fixed security bug in JavaScript in class.options_phpcms.php
   that could expose the GUI password

May 04 2003 (hpoe)
 * added new (PHP 4.3) phpinfo() CSS to class.options_phpcms.php

May 04 2003 (tobiasd)
 * Demo: included meta tag which allows HTTP indexer to spider the pages
 * HTTP Indexer: Fixed notice message when error_reporting set to E_ALL

May 03 2003 (beate76)
 * included icon for symlink (linux) and .lnk (M$) in fm

May 03 2003 (e157m369)
 * fixed a small display-bug with the error-codes-list in class.options.
 * bugfixed include-trap for SCRIPTs in class.realtime.

May 03 2003 (beate76)
 * fixed bug #731490: Only one Mail2Crypt-Tag per line replaced

May 03 2003 (tobiasd)
 * fixed bug #731317: Mail2Crypt - Hardcoded path
 * Added missing trailing slash in default.php ($this->MAIL2CRYPT_IMG)

********************************************************************************
*                           phpCMS 1.2.0 Beta1                                 *
********************************************************************************

May 01 2003 (tobiasd)
 * Some changes to avoid error messages when error_reporting is set to E_ALL
 * Change mcyra.homeip.net to phpcms.de
 * Added file header to all PHP source files

Apr 29 2003 (mjahn)
 * fixed bug: online-editor can now also handle files with quotings

Apr 29 2003 (e157m369)
 * Corrected some more mistakes in NEW_FEATURES and added new entries.
   Sorted and re-categorized all entries by the modules they concern.
 * added the icons /gif/info.gif and /gif/filemanager/delete_all.gif
 * changed the icon to delete all files in cache-view.
 * added info-title and icon to the $DOCUMENT_ROOT descriptors, task #727396.

Apr 28 2003 (tobiasd)
 * Corrected some grammar and typing mistakes in NEW_FEATURES
 * Adjusted test header in parser.php

Apr 28 2003 (ignatius0815)
 * GUI shows now correct phpCMS version number directly after update (before
   default.php was updated to the new version)
 * Completely rewrote the function ReadFields in class.parser_file_phpcms.php
   and splitted it up into 3 functions (trimField, splitFieldLine, ReadFields)
   This fixes several bugs:
    - field-Delimeters can be now longer then 1 character (bug #705902)
    - content-Plugins work again
    - more then one field definition can be made in a single line
    - field definitions doesn't has to start anymore exactly at beginning of a
      line
    - hopefully much cleaener and easier to read code :-)
 * Added a file NEW_FEATURES with a list of new features in phpCMS 1.2.0

Apr 27 2003 (tobiasd)
 * Added header to parser.php for test
 * Add check for PHP version to shell indexer
 * Set path variables in shell indexer automatically
 * Moved class cookie_container to a new file

Apr 26 2003 (Ignatius0815)
 * fixed bug #689707: Problems when MENU-entry is missing in project file

Apr 25 2003 (Ignatius0815)
 * Changed version number from 1.1.10 to 1.2.0 in some more locations
 * fixed bug #715197: Small problems with <PHPCMS_INCLUDE>

Apr 24 2003 (tobiasd)
 * Added missing string for filemanager (dir list -> edit file) in language
   files

Apr 24 2003 (e157m369)
 * updated the readme-files in /parser/readme.
 * changed all relevant version-infos from 1.1.10 to 1.2.0 and CVS to Beta1.
 * moved automatic setting of $DEFAULTS->DOMAIN_NAME back to default.php
 * added paths for Mail2Crypt to default.php, already included in class.setup.

Apr 23 2003 (e157m369)
 * bugfixed: on changing the cache_dir the navigation has to be reloaded

Apr 23 2003 (tobiasd)
 * remove orphan class Fehler from online editor

Apr 23 2003 (e157m369)
 * bugfixed: #720485, parser shouldn't echo "\n" before PAX.
 * additionally fixed a bug in class.pax where a space was set in front of each
   PAX-Tag, caused by a false counting.
 * fixed non-traped includes on SCRIPT-files in class.realtime.
 * bugfixed: #720998, Unexpected behaviour of "Global Home" setting.

Apr 22 2003 (hpoe)
 * cleaned up left overs of PAX MailCrypt, renamed all instances to Mail2Crypt
 * fixed double issue bug #706292 Hardcoded link to parser/gif/at.gif in demo
    - removed hard coded link in /demo/index.htm
    - made paths to images and JS used by Mail2Crypt configurable through GUI
 * for a grace period parser will recognize both <!-- MAILCRYPT mail@domain -->
   and new <!-- MAIL2CRYPT mail@domain -->
 * removed left over call to PAX MailCrypt from class.pax_phpcms.php
 * removed i18n code  (to be implemented in next release)
 * updated usage instructions in topref.php plug-in

Apr 22 2003 (e157m369)
 * bugfixed: #724852, File-Indexer inaccessible from GUI
 * removed unused $DEFAULTS->HOMEURL
 * added $DEFAULTS->DOMAIN_NAME with config in GUI
 * bugfixed: #706923, HTTP redirect header uses relative URI

 * set the edit-tags in non-edit-mode to real empty instead of ' '.
 * bugfixed: #715302, Problem with quotes in online-editor.
 * set the cookie-names of Editor and DebugTool from the array-constructed
   to two separate cookies each.
 * added functions for time-measurement to class.phpcms.
 * corrected debug-timer and made the timestamps available via $PHPCMS->TIMER
   on every parsing.

 * changed simple naming default.php in language-files to
   '.$PHPCMS_INCLUDEPATH.'/default.php.
 * removed $this->DOMAIN_NAME from default.php and commented out its config.
 * added setting $DEFAULTS->DOMAIN_NAME to $SERVER_NAME in parser.php.
 * bugfixed: #725042, Usage of non-existent error codes.

 * changes in FileManager:
    - fixed small bug with the 2nd-instance sortation.
    - fixed small bug with filelist-delimiter in copy/delete.
    - fixed bug with displaying cache-files in copy/delete-lists

Apr 21 2003 (tobiasd)
 * garbage collector from session class now doesn't delete .htaccess file
 * HTML template is now valid XHTML

Apr 20 2003 (tobiasd)
 * fixed bug #724696: phpCMS creates js_mailcrypt.js even
                      when Mail2Crypt disabled

Apr 20 2003 (e157m369)
 * moved Version/Release-Settings from class.layout to class.phpcms.
 * changes in and for the DebugTool:
    - bugfixed: #694694, debug-tool using with an already cached file.
    - bugfixed: #705207, loading frameset after login set to target "_top".
    - bugfixed: #705046, error with sorting incomplete menu-classes.
    - made possible to call the DebugTool with "&debug" only.
    - added the "back to page"-link on the login-form of the DebugTool.
 * added special prepareds for QUERY_STRING AND REQUEST_URI to class.phpcms.
 * changed all if's with "stristr($QUERY_STRING, 'param=')" to use the new
   "$PHPCMS->_query_string['param']" with strtolowered array-keys.
 * changes in and for the FileManager:
    - bugfixed: is_executable() in FileManager on Win with PHP-error-warning.
    - excluded FileManager's instant-actions from cache-view.
    - made textarea-size in FileManager configurable in Config-GUI.
    - added GUI-configurable display-shortening of long filenames both
      in FileManager and CacheView with the full name in a title.
 * changes in Configuration/Setup:
    - bugfixed: #715246, added permission-trap on writings to default.php.
    - secured saving of changed password in configuration.
    - moved the defaults-converter to new class.setup_phpcms.php.
    - synchronized the defaults-array with the actual default.php.
 * updated language-files:
    - build subarray for SETUP with the converter-entrys.
    - added messages for default.php saving-trap and FileManager configurations.

Apr 19 2003 (mjahn)
 * fixed bug #707144 indexer and mail2crypt wont work
     (thx to Mike Constabel for his help)

Apr 19 2003 (tobiasd)
 * change plugin tags to new syntax

Apr 18 2003  (hpoe)
 * fixed bug #723693  "Parser won't run if referrer log dosn't exist"
 * topref.php: fixed incorrect function call

Apr 18 2003 (tobiasd)
 * Task #74596: Convert options helpfiles to static HTML

Apr 17 2003 (tobiasd)
 * class.parser_file_phpcms.php: changes and cleanup in hardcoded tags
 * fixed bug #721249: Password check not case sensitive
 * relative link to doc (GUI, stealth mode)

Apr 16 2003 (hpoe)
 * removed dependence between referrer logging and statistics settings
 * added reload lock
 * renamed log file to referrer.txt

Apr 15 2003 (hpoe)
 * Statistics Module security enhancement: added htmlentities() to referrer
   links
 * Top Referrer and Last Referrer logging
    - a log of referrers may now optionally be kept. This requires stats to be
      turned on. As discussed in the forum, this was implemented directly within
      the parser for performance reasons
    - added a switch to the GUI under statistics that defaults to 'off'
    - processing and display is done by the accompanying script "topref.php"
      that may be integrated as needed as either a plug-in, via PAX or the
      script method
    - changes were made to: class.options_phpcms.php, class.cache_phpcms.php,
      default.php, language.en/de, option_en/de.htm; added seite3.htm to demo

Apr 15 2003  (beate76)
 * added an icon for databases (mdb) in filemanager
 * fixed bug in fm: instead of csv.gif was written cvs.gif, also changed
   the name of the icon.

Apr 15 2003 (mjahn)
 * fixed little bug #721948

Apr 14 2003 (hpoe)
 * fixed bug #721244 Wrong navi icon for File Indexer (language.en)
 * updated inline documentation to reflect changes to debug mode (debug tool)

Apr 14 2003 (e157m369)
 * changed GUI-password-handling to cookie with crypt, added logout-function
 * cleaned up the /parser/gif-directory and tried to categorize the files.
    - added icons for the new filemanager.
    - moved all images needed for the http-indexer to /gif/indexer.
    - gave fileindexer.gif and statistics.gif a transparent-background.
    - copied logo.gif for navigation-bar from class.images.
 * corrected cell-sizes and image-filenames in HTTP-Indexer.
 * The FileManager was completely rebuild and is now all new:
    - created registry for filetypes and added many icons.
    - created registry for some template-files used for creating a new file.
    - made the filelist sortable ascending and descending by each property.
    - improved handling of checked files on cancel from copy or delete.
    - now you can switch between highlighter and editor without loosing changes.
    - browsing a file will now open in a new window.
    - now with multi-copy/rename:
       - optional use of a prefix and/or suffix for each selected filename or
         directory.
       - already existing targets will re-prompt for overwrite of each or all.
       - nearby every possible error is trapped now with a special message.
    - many, many cosmetical bugfixes...
    - and of course: updated the language-files ;-)
    - just to complete the officials: bugfixed #74480, #704951 and #704948
 * rebuild and improved the secure-stealth-check into class.phpcms

Apr 13 2003 (beate76)
 * Fixed bug #720270 (Secure Stealth Mode kills parser)

Apr 11 2003 (beate76)
 * deleted entries for multilingual support in default.php

Apr 11 2003 (ignatius0815)
 * removed the check for php-Version > 4.0 in class.lib_phpcms.php as the check
   is made already in parser.php
 * added workaround for php bug with output-buffering (bug #706207) which
   resulted in a destroyed page design when using cookies in scripts/pax/plugins
   with certain php versions (validated with php 4.2.3)

Apr 08 2003 (tobiasd)
 * fixed bug #712700: Wrong text in HTTP-Indexer
 * corrected some english language strings

Apr 07 2003 (ignatius0815)
 * added "PARENTCLASS" parameter to the {MENU} placeholder
 * optimized function 'GetPageClass' in class.parser_template_phpcms.php

Apr 07 2003 (beate76)
 * fixed problem: Parser now doesn't terminate in Secure Mode,
   when $_GET_POST-variables end with "file", e.g. downloadfile

Apr 04 2003 (beate76)
 * fixed bug #712706 (Missing linebreak in statistic)
 * fixed bug in class.parser_search_phpcms.php: layout of prev- and next-links
 * included <SEARCH_MIDDLE> in home.tag to separate prev- and next-links.
   if nof defined, set to " ".

Apr 04 2003 (mjahn)
 * fixed bug #715276 (small bug in class.parser_page_phpcms.php)
             #715279 (Small Type in GUI)
             #715292 (Confusion with name of variable for global home directory)

Apr 01 2003 (beate76)
 * Edited class.parser_search_phpcms.php: deleted redundant & in "$self?&query="

Mar 25 2003 (beate76)
 * Edited demo-layout for OE (end_edit.tpl, footer.tpl)

Mar 24 2003 (mjahn)
 * fixed bug #708482 (cache-GUI now is alphabetical sorted)
 * fixed bug #708484 (multi-domain-environment)

Mar 24 2003 (beate76)
 * Fixed bug #703907 (File Indexer page missing HTML framework)

Mar 23 2003 (beate76)
 * HTTP indexer - changed icons and size of them in
   class.lib_indexer_liste_phpcms.php

Mar 22 2003 (tobiasd)
 * GUI - Configuration: link to show password is now visible only when
   Javascript is enabled

Mar 21 2003 (tobiasd)
 * fixed bug #707484: Javascript problem with Opera 5 and phpMail2Crypt

Mar 21 2003 (mjahn)
 * added png to the fixed extension in the GUI and in class.cache_phpcms.php

Mar 21 2003 (beate76)
 * little changes in demo (mainly adaption of pathes)
 * deleted JS-higlighting-code in home.tag
 * deleted call of langs2link-Plugin in demo

Mar 20 2003 (tobiasd)
 * HTTP indexer: several enhancements and bugfixes
   changed all indexer files and the language files
   - editing of profiles now possible
   - new settings to replace url parts after indexing
   - commented out debug messages
   - test search and analyze words now works together with gzip
   - minor corrections in language strings
   - enhanced profile wizard (path settings for spidering/inclusion/exclusion
     can be edited)
   - fixed bug when entering empty inclusion/exclusion string
 * Filemanager
   - fixed bug #706328: Wrong filesize in filemanager

Mar 17 2003 (ignatius0815)
 * fixed bug #698114: Problems with Cookie in Online-Editor
 * fixed bug #705024: Problems with urlencoding in online-Editor
 * redone bugfix #698117: Problem with online-editor and empty content-fields
   (and removed the fix for the bug, done by e157m369 on Mar 9 2003 as it
   didn't fixed the reason but only the result of the bug)

Mar 15 2003 (e157m369)
 * bugfix: also die on PHP<4 in version-checks in parser.php and indexer
 * bugfix 703878: fixed "term excluded from search" in class.parser_search

Mar 15 2003 (hpoe)
 * fixed an fopen()  bug in class.search_indexer_phpcms.php

Mar 13 203 (hpoe)
 * fixed incorrect hex color codes that were missing the "#"
 * (hopefully) fixed glitch in login screen display
 * added parameter $doctype to function header_html that defaults to "xhtml1t"
    GUI navigation calls header_html() with parameter "html4t"

Mar 12 2003 (hpoe)
 * fixed bug #700193 "Invalid HTML in demo"

Mar 12 2003 (mjahn)
 * class.realtime_phpcms.php
   - fixed bug #636228: now the cachefile will be deleted, when discquota is
     full

Mar 12 2003 (tobiasd)
 * class.parser_template_phpcms.php
   - fixed bug #700196: active link was not recognized in menu (finally)
 * class.pax..., class.parser_file..., class.search_indexer..., class.edit...
   class.layout..., class.lib_indexer_universal..., plugs/form.php
   - use $DEFAULTS->DOCUMENT_ROOT not $PHP->GetDocRoot()
   - use $DEFAULTS->SCRIPT_PATH not $PHP->GetScriptPath()
   - use $DEFAULTS->SCRIPT_NAME not $PHP->GetScriptName()
   - removed 'global $PHP;' where not needed (anymore)
 * class.pax..., class.parser_file..., class.realtime..., class.mailcrypt...
   - fixed bug #702133: phpMail2Crypt doesn't work inside of phpCMS tags
   - removed phpMail2Crypt code from PAX file
   - created new class for phpMail2Crypt

Mar 12 2003 (e157m369)
 * bugfix: Tags in debug=CONTENT_REP (ex show=REPLACED_PAGE) where not replaced
 * rebuild the debug-system into a new class with some 'bugfixes'
    - debug-mode is now available via ?debug=debug, no more ?show=debug
 * bugfix and improved cookie-timeout in online-editor and debug
 * bugfix #700196: active link was not recognized in menu (theoretical)
 * corrected links to /demo/index.htm in nonstealth-startpages

Mar 11 2003 (hpoe)
 * added bilingual phpCMS start pages (en/de)
    - /parser/help/index_stealth.de.html
    - /parser/help/index_stealth.en.html
    - /parser/help/index_nonstealth.de.html
    - /parser/help/index_nonstealth.en.html
 * removed old start pages
    - /parser/help/start1.html
    - /parser/help/start2.html

Mar 11 2003 (hpoe)
 * further work on bug #698328 "Sourcecode PHP-Info wrong"
 * GUI:
    - created transparent GIFs for GUI section links
    - renamed link to File-Indexer to... (guess what)
    - chose slightly lighter hue of green
    - improved GUI XHTML compatibility
      - rewrote class document in class.layout_phpcms.php
      - added function header_html (allows for future global doctype changes)
      - rewrote function DrawHeader
      - updated functions DrawFrameset, DrawMenuEntry, DrawFooter, CheckUpdate,
        DrawNavi

Mar 9 2003 (e157m369)
 * added entries for filemanager_startdir to option-helpfiles.
 * task #73053: Added meta-Tag for 'noindex, nofollow' to GUI-frameset and
    HTTP-Indexer html-output.

Mar 9 2003 (tobiasd)
 * class.parser_template_phpcms.php: added $PHPCMS_INCLUDEPATH to include path
   fixes warning when open_basedir is set
 * class.options_phpcms.php: changed PCRE delimiters from '�' to '/'

Mar 9 2003 (e157m369)
 * completely rewrote class.lib_indexer_checksearch to parse the search-check
   via the parsers class.parser_search, temp. faking the parser to this class.
 * moved the version-check to the top of the parser.php, because PHP>4.0.1 has
   to be verified before the class.phpcms is included.
 * bugfix #698117: online-editor will now replace an empty-submitted field with
                   an '<!-->' to save the field.
   (this bugfix is obsolete and was redone by ignatius0815 on March 17)

Mar 9 2003 (tobiasd)
 * home.tag: corrected entity encoding in PAXPHP blocks

Mar 8 2003 (hpoe)
 * worked on bug #698328 "Sourcecode PHP-Info wrong"

Mar 8 2003 (ignatius0815)
 * changed default language for the phpCMS GUI from german to english

Mar 8 2003 (e157m369)
 * Rewrote Search-Results-Function, recreated it into it's own class-file and
   moved the search's helper-funtions to this class.parser_search_phpcms.php.
 * IMPORTANT: changed tag-handling:
     A non-existent 2nd part will no longer cause an error if it is boolean
     false, only 2nd parts which are === '' will trigger a tag error 16.
     So on defining tags via PHP-Code:
       The 2nd part not set or explicitly set to false will not error on this
       tag. The parser will replace the tag's appropriate part in content to
       '', but the tag-var itself will stay boolean false all the time.

Mar 7 2003 (tobiasd)
 * class.cache_phpcms.php
   - changed code to recognize and handle '..' in parameter file

Mar 7 2003 (hpoe)
 * modifications to file indexer GUI (see below)
 * added class select_radio() to class.form_phpcms.php

 * new stop words logic in file indexer:
    - renamed "stopwordfile" to "global stop word file"
       The global stop word file (stop.db) is the one located in
       /parser/include/
    - added option to "use local stop words file" to GUI. Defaults to OFF.
       Local stop word files must be located in the data directory the user
       specifies.
       If the local stop.db does not exist, an attempt is made to copy the
       global stop.db, and, failing that, to create an empty stop.db in the
       data directory
    - added option for "stop words optimization" to GUI. Defaults to OFF
       This fixes bug #698268 "Missing error-handling in file-indexer"
       (Needs to be implemented in HTTP indexer as well.)

 * fixed bug #698290 "Problems with setting of "Data directory" in old indexer"
    - paths may now be entered in the file indexer GUI either with or without
      a trailing slash

 * renamed all $MESSAGES for both HTTP and file indexer

 * removed $SEARCH_GZIP from default.php
    - formerly, when search indices were gzip'ed the search form had to
      contain a hidden field <input type="hidden" name="gzip" value="on">.
      If the value of "gzip" did not match the actual file set, search
      would return no result.
    - this is now handled automatically within the parser

Mar 6 2003 (mjahn)
 * fixed bug #698675
 * fixed a little bud in the EDIT-mode

Mar 6 2003 (e157m369)
 * added check for existing chache-dir in cache-view in class.options.
 * some updates in default.php and the converter in class.options:
    - moved version-check-vars from converter to class.layout for use on login.
    - added blacklist of vars, which exist in older versions, but are not
      needed anymore. those will not be converted.
 * changes to GUI-login in class.layout:
    - added a box on blacklisted password-login to show the blacklist.
    - changed login not to check the password with the blacklist if the
      default.php has not the recent version.

Mar 6 2003 (tobiasd)
 * class.gzip_phpcms.php:
   - removed redecleration of function gzip()

Mar 5 2003 (hpoe)
 * class.realtime_phpcms.php:
    - fixed small glitch introduced in rev1.7.2.3

Mar 5 2003 (ignatius0815)
 * fixed bug #696511: Tags, which were created in plugins, didn't work
   correctly

Mar 5 2003 (e157m369)
 * bugfix: removed link on spacer-gif in filemanager toolbar
 * added is_dir corrections in filemanager not to try loading invalid startdir

Mar 5 2003 (hpoe)
 * options_en.htm and options_de.htm:
    - added Mail2Crypt section
 * stop.db:
    - changed stop words to lowercase
    - added some common terms, and removed "php"
 * Demo:
    - index.htm:
      - added showcase for new (PAX free) Mail2Crypt
      - added showcase for new xml-style ignore tag <phpcms:ignore>
         (sorry, it's invisible ;-) |)
    - suche.htm (search): added showcase for xml-style noindex tag
      <phpcms:noindex>

Mar 5 2003 (mjahn)
 * class.gzip_phpcms.php added
    - removed the php3-compatibility
    - fixed bug #696472
 * class.realtime_phpcms.php
    - removed the php3-compatibility
    - cleaned the class checkfile
 * class.cache_phpcms.php
    - now the cachefile are recreated if the gzip is changed
    - some other little fixes
      (see http://phpcms.de/forum/showthread.php?id=3264&eintrag=10)
    - fixed bug #634963 in non-stealth-mode
 * class.options_phpcms.php
    - removed the php3-compatibility
  * class.lib_phpcms.php
    - optimized the class

Mar 5 2003 (e157m369)
 * removed all the code enabling class.gzip_php3-support
 * deleted class.gzip_php3, PHP 4.0.1 is min. condition for phpCMS >= 1.2.0
 * set version-check in parser.php to PHP 4.0.1 to remove the class.gzip_php3
   and not to cause errors with array_merge_recursive()'s
 * set input-field of GUI-login on password-error to empty

Mar 5 2003 (hpoe)
 * Ignore Tag: changed syntax to xml-style <phpcms:ignore>blah</phpcms:ignore>
   (cf. Feb 26 2003)
    - <phpcms:ignore> takes effect in the parser
      (class.parser_file_phpcms.php), and the file-indexer
      (class.search_indexer_phpcms.php)

 * Noindex Tag: changed syntax used in content files to xml-style
  <phpcms:noindex>blah</phpcms:noindex>
    - before caching, and sending pages to the browser, the xml-style ingnore
      tag is converted to comment syntax
       <!-- PHPCMS_NOINDEX -->blah<!-- /PHPCMS_NOINDEX -->
      so that pages may validate as (X)HTML
    - the file-indexer will ignore anything within comment-style noindex tags

 * HTTP-Indexer:
    - class.lib_indexer_newindex_phpcms.php:
       - modified sort stop.db routine ()
       - bugfix for warnings "unlink failed" in function start_create()
    - class.lib_indexer_universal_phpcms.php:
       - rewrote function cleanChars()
       - rewrote revertDiacritical($body)
       - added function string_tolower()
       - modified function mstrip_tags() - now also strips <script> and <style>
         tags
       - modified function MakeShortWords()
       - modified function prepare_body()
       - fixed implementation of noindex tag
       - fixed routine that writes words.tmp file
       - numerals are now indexed even if shorter than min word length

 * File-Indexer:
     - class.search_indexer_phpcms.php:
     - rewrote function cleanChars($body),
     - numerals are now indexed even if shorter than min word length

 * Search Output
     - tweaked performance a little
     - case insensitive comparison of stop words is no longer needed

 * restored a GUI change by e157m369 I had mistakenly removed (cf. Feb 26 2003)

Mar 5 2003 (e157m369)
 * bugfix #696494: corrected the check for loading debug when cache-file exists
 * bugfix #696464: made navigation frame in GUI scrollable
 * Refines in FileManager:
    - bugfix #687991: errors on file delete will be trapped now
    - bugfix: errors on file upload will also be trapped now
    - bugfix: CHECKDIRSIZE switched off will not return '0' but boolean false
    - refined the output of dir- and filesizes and some other cosmetics
 * new setting: $DEFAULTS->FILEMANAGER_STARTDIR
 * bugfix: browsing-links in cache-viewer now link to the cached urls

Mar 5 2003 (tobiasd)
 * made user.php work correctly with short_open_tag=Off

Mar 4 2003 (e157m369)
 * rewrote class.phpcms.php:
   now supporting even multidimensional arrays via special GET-vars, which
   are separated by one or more free definable string(s).
 * bugfix #689252: the new function for rewriting the GET-vars fixed this.

Mar 4 2003 (beate76, e157m369)
 * bugfix: http-indexer
    - fragmented special characters, caused by a wrong order of two functions
    - included the replacement of &amp; in revertDiacritical();
 * bugfix: search didn't run caused by case-sensitive matches in
           class.parser_template

Mar 3 2003 (e157m369)
 * bugfix with mail2crypt errorcodes in language-files and class.parser_file
 * bugfix #695941 and #695972
   and made the "?show=debug"-page compatible to non-stealth-mode

Feb 26 2003 (hpoe)
 * Mail2Crypt now works independent of PAX!
    - disabled PAX MailCrypt
    - reimplemented Mail2Crypt in class.parser_file_phpcms.php
    - removed support for embedding JS code via <!-- MAILCRYPT embed -->
      (This now behaves the same as <!-- MAILCRYPT include --> )
    - removed file mailto.php from CVS
    - removed <noscript> link to server side script "maito.php"
      This was done to improve security. Users should LINK TO A SECURE
      CONTACT FORM instead!

Feb 26 2003 (hpoe)
 * implemented <!-- PHPCMS_IGNORE --> in class.parser_file_phpcms.php
    This allows to temporarily "comment out" HTML code in content files
 * fixed small GUI bug that made the "fixed file endings" textarea disappear
   when stealth-mode is on [reversed 2003-03-05]

Feb 26 2003 (hpoe)
 * class.search_indexer_phpcms.php:
    - rewrote function cleanChars($body), revertDiacritical($body)
    - added function string_tolower()
 * class.parser_template_phpcms.php:
    - added function string_tolower()

Feb 26 2003 (e157m369)
 * refined the /parser/plugs-files not to produce errors with the online
   editor, reformated the code and optimized them for work with phpCMS 1.2.0.
 * task #70714: added switch to completely deactivate the online editor in GUI.
    - added entry in both options-helpfiles.
    - added info to the readme-files for the editor.
    - changed the 'tester'-password in /demo/home.ini to a blacklisted password
      and reformated the .ini's.
 * some refines with the online-editor, e.g. password-blacklist check.
 * added a switch to the GUI for error 16 with empty TAGs. See thread #2158.
   Also added the entrys for this in languages and options-helpfiles.

Feb 26 2003 (ignatius0815)
 * reformated some hardcoded html-code in the sourcecodes

Feb 25 2003 (ignatius0815)
 * added information about the possibility to use multiple passwords for the
   online-editor to the editor readme-file

Feb 25 2003 (e157m369)
 * included the submitter for the phpcms-news mailing list into the GUI
 * separated the update-info from GUI navigation into an iframe
 * added /parser/include/class.phpcms.php
 * some changes to parser.php
    - cleaned up parser.php and added some comments.
    - added loading class.phpcms.php to get a clean, PHP-version-independent
      scope on startup, including a function to comfortably (re)set
      system vars.
    - added a check for PHP4, otherwise the parser will not run.

Feb 24 2003 (e157m369)
 * some changes to GUI:
    - made all path-sets in config to come up from DOCUMENT_ROOT
    - created two-lined field-descriptions without link on both
    - updated default.php and converter-array
    - updated and created entries in options-helpfiles
    - reformatted options-helpfiles and created the back-links
    - some changes in language-files
    - refined the internal handling of the JS-Field-Hiding
 * added /parser/gif/back.gif used in options-helpfiles
 * cleaned up and updated all the files in /parser/readme
 * bugfix #688018: re-added missing editor-parts in language-files

Feb 22 2003 (hpoe)
 * Finished implementation of global P3P headers:
    added new function p3pHeader() to class.lib_phpcms.php that is being called
    as $PHP->p3pHeader() in class.cache_phpcms.php and class.gzip4_phpcms.php
 * fixed quotes in named array in class.lib_error_phpcms.php

Feb 22 (mjahn)
 * refined the cache-view in the GUI, now with cache-endings (.gz, .dyn, .htm)
 * added a second submit button to the GUI-configuration

Feb 18 2003 (e157m369)
 * task #68911: Moved /parser/template/print.css to /parser/doc,
                deleted the not used standard.css

Feb 17 2003 (mjahn)
 * killed Bug #688065 and #688001 in the class.options_phpcms.php

Feb 17 2003 (ignatius0815)
 * Parser skips now unwanted blank lines in the menu-template

Feb 15 2003 (ignatius0815)
 * removed TABs from language.de & language.en

Feb 15 2003 (beate76)
 * class.stat_phpcms.php :
     inserted a function to show a message if statistic is turned off
 * stat.txt :
     deleted the 2 entries in order to have a good working statistic sometime
 * language.de, language.en :
     inserted new messages for stats (id 130, 167, 168)

Feb 14 2003 (mjahn)
 * bugfix #634951: the cache-files are now saved with md5-filenames

Feb 13 2003 (mjahn)
 * class.search_indexer.php :
     file-indexer alternatively indexes the {TITLE} if there's no value in
     {TITEL}

Feb 13 2003 (hpoe)
 * parser.php:
    - fixed bug #634967 - Parser-GUI hangs when onlineeditor is on
 * class.edit_phpcms.php:
    - fixed bug #685940 - Cookie not deleted after editor logout

Feb 12 2003 (hpoe)
 * class.realtime_phpcms.php: dynamic server cache now uses <?php instead of
    a short open tag.

Feb 12 2003 (e157m369)
 * refined the bugfix #679022 to reload the startpage in class.layout
 * some minor bugfixes and refines in class.options
    - bugfixed the password-input
    - bugfixed marking the preselected value in option-lists
    - refined the navigation-frame-reload on changing the language in config

Feb 12 2003 (mjahn)
 * Refined the GUI-Configuration (class.options & class.layout)
   if the configuration is changed in admin-interface, the navi-frame will be
   reloaded, so the language-settings will take effect also in the navi-frame
 * fixed bug #679022: after a successfull login the start-page will be reloaded
   into the right frame
 * fixed bug #629465: the http-indexer now also indexes HTML-title-Tags with
   other HTML-Tags inside

Feb 11 2003 (e157m369)
 * Refined the GUI-Configuration in class.options:
    - Bugfixed the Field-Hiding with Gecko-based browsers
    - Added blocking the DOM-JS for Field-Hiding from older browsers
    - Added DOM-JS text-selektors to the radio-buttons

Feb 10 2003 (hpoe)
 * removed P3P sample statement in class.options_phpcms.php
    users should create their own and not be tempted to use the sample
 * hid language support settings (again) in class.options_phpcms.php

Feb 10 2003 (e157m369)
 * Refined the GUI-Configuration in class.options. The Field-Hiding is now done
   via JavaScript and no more serverside as mentioned on Jan 30 below.
 * Refined the Frameset and the Font-Style in class.layout.
 * Refined some Font-Styles and the MenuBar in Docu-Templates and Helpfiles.

Feb 05 2003 (mjahn)
 * Changed class.options_phpcms.php so that the string identifiers of
   $MESSAGES are included in inverted commas

Feb 05 2003 (eventmedia)
 * tag file: changed html entities into decimal code,
             left entity names within file (commented out)
 * stripped XML-DOC-declaration
 * Menu template: inserted missing
   {TOC.MAIN.PRE} / {TOC.MAIN.PAST}
 * Template files including menu template:
   nicer formatting of html source
   added some html comments for better explanation

Feb 03 2003 (ignatius0815)
 * Changed class.parser_file_phpcms.php so that empty content fields are not
   removed anymore when content file is read. This should solve the problems
   with the online-editor "forgetting" empty fields

 * fixed bug #633955 and #673483:
   Removed all parts from the parser which stripped leading spaces and blank
   lines. This should solve all problems with <PRE> Tags etc.
   As a result it's now the task of the user to avoid blank lines etc.
   in the templates and content files, if he want's to have a clean output.

 * Cleaned up template files of the demo (removed some blank lines etc.)

Feb 02 2003 (ignatius0815)
 * updated chapter 7 (change password) in the readme.txt & liesmich.txt
 * corrected a typo in the file start1.html
 * removed some doubled lines in demo/seite1.htm
 * changed the path to the search-data directory from /phpcms/suche to
   $home/suche for one link in the file demo/suche.htm
 * changed method from "get" to "post" in the form tag in demo/suche.htm
   so it works also without stealth-mode (which is default in new
   installations)
 * reformated CHANGELOG to a width of 80 characters

Jan 30 2003 (hpoe)
 * fixed bug #677001 "Misleading error message in non-HTTP Indexer"
 * fixed bug #634959 "non-stealth mode not supp. in cache GUI"
 * fixed bug that would not allow access to documentation from GUI in
   non-stealth mode
 * fixed bug in GUI Cache where subdirectories and .htaccess were displayed
 * fixed bug introduced on Jan 24 2003 where changes to P3P headers could
   not be saved

 * cleaned up Indexer stopwords (stop.db)

 * i18n:
    - added $MESSAGES   ['I18N'][xx] to "language.xy"
    - added i18n settings to class.options_phpcms.php

    All i18n features are hidden and non-functional untill the first
    alpha realease of class.multilingual_phpcms.php
    I have included these here so I can safely integrate i18n
    development without creating a branch.

  * changes to GUI
    - the password is now displayed as type="password" (*******)
    - a number of sub-settings are hidden when their main switch is off.
      Hope this will reduce clutter for those not using these features.
      This is true for:
      - Server Cache -> Server Cache Directory
      - Client Cache -> Livetime of Proxy/Client Cache
      - Steatch Mode -> Secure Stealth Mode
      - Debug Mode -> Custom error page -> Custom error-404 page
      - Send P3P Header -> Globaler P3P Policy Heade -> P3P Policy href
      - Statistics -> all settings
     There remains a cosmetic problem with this since the Configuration panel
     needs to be reloaded after changes to any of these main switches.


Jan 24 2003 (hpoe)
 * fixed bug in class.options_phpcms.php that would set all variables with
   similar sounding names to the same value.

Jan 23 2003 (hpoe)
 * parser.php, class.options_phpcms.php, default.php:
   - within parser.php implemented .htaccess security fix proposed by [TOM]
     (http://phpcms.de/forum/showthread.php?id=1285)
   - added "Secure Stealth Mode" switch to GUI
   - Secure Stealth Mode will prevent files from being accessed via
     'parser.php?file='.
   - defaults to 'off'.

 * Added logic to parser.php to include class.multilingual_phpcms.php when
   'Language Support' is ON (i18n files are not in CVS yet)

 * Added non-configurable '$PW_MIN_LENGTH = 6' to default.php,
    and an error message to the login-in screen that warns when
    password < 6 chars

 * class.options_phpcms.php, default.php, class.cache_phpcms.php,
   class.gzip_php3.php, class.gzip_php4.php:
   - Added P3P support (Plattform for Privacy Preferences Project -
     http://w3c.org/P3P/)
     - allows to send a global (site wide) P3P header
     - defaults to 'off'.
   - introduced bug: changes to P3P headers won't be saved :(

 * modifications to demo
   - implemented search term highlighting (at this time needs PAX turned on -
     will try to remove)
   - added global search field

 * class.lib_session_file.php: fix for warnings "unlink failed" in functions
   collect_garbage() and delete()

Jan 21 2003 (e157m369)
 * included the 404-error-handler, see
   http://phpcms.de/forum/showthread.php?id=2652&eintrag=60
 * fixed the workaround with the dummy-value in search, see
   http://www.phpcms.de/forum/showthread.php?id=2426

Jan 19 2003 (hpoe)
 * changes to non-HTTP indexer(class.search_indexer_phpcms.php):
    - numbers and numeric separators (0-9 . , ) are now being indexed
    - replaced function make_german() with functions cleanChars() and
      revertDiacritical()
    - new: sort stopwords in stop.db, remove duplicate entries, and write
      stopwords back to stop.db
    - implemented PHPCMS_NOINDEX tag to exclude passages of text from being
      indexed (function write_file_entry())

  * changes to HTTP indexer (class.lib_indexer_universal_phpcms.php,
    class.lib_indexer_newindex_phpcms.php)
    - replaced function make_german() with functions cleanChars() and
      revertDiacritical()
    - sort stopwords in stop.db, remove duplicate entries, and write stopwords
      back to stop.db
    - implemented PHPCMS_NOINDEX tag to exclude passages of text from being
      indexed (function index_page())

   * changes to full text search (class.parser_template.php)
    - user notification if search term is stopword
    - user notification if search term is a "nono" - abort search
    - allow searching for numbers

Jan 19 2003 (e157m369)
 * improved backup-function in the default.php-Converter
 * bugfix: in http-indexer session_id was set behind the name of the menulink
   and not the href

Jan 18 2003 (hpoe)
 * language.de and language.en: fixed quotes in named array

Jan 18 2003 (e157m369)
 * refined the inclusion of the http-indexer
 * deleted the citroman-links

Jan 17 2003 (hpoe)
 * Updated $MESSAGES['NAVIGATION'][26] ("No access without individual password)
    to more accurately reflect that without an individual password the GUI and
    parser still work, only access to the GUI is denied.

Jan 15 2003 (hpoe)
 * fixed bug #668777 short PHP open tag in class.images_
 * Renamed function AddIdentTag() to addIdentTag()

Jan 15 2003 (e157m369)
 * reformated the parser.php
 * changed the order of the navigation-points in class.layout and added the
   http-indexer
 * changed the class.layout-$MESSAGES to associative $MESSAGES['NAVIGATION']
 * moved the navigation-images from /gif to /gif/nav while renaming some and
   reworked some images

Jan 13 2003 (bjmg)
 * Removed the spidered english documentation
 * Changed the title in the english description of the settings
 * Added MENU and MENUTEMPLATE to help.*.ini

Jan 11 2003 (hpoe)
 * enabled adding "parsed by phpCMS" comment with XML header tags (bug #634924)
   This required changes to class.parser_file_phpcms.php and
   class.parser_phpcms.php
   Added function AddIdentTag() to class helper.
 * Renamed PAX MailCrypt to "Mail2Crypt" to avoid name conflicts with mail
   encryption software mailcrypt
 * Fixed display of examples on /demo/index.htm
 * Minor corrections of the description within .ini file

Jan 11 2003 (e157m369)
 * patch included in class.parser_template to enable search-form and results in
   one .htm-File

Jan 10 2003 (e157m369)
 * added the reload-link in the GUI navigation-bar in class.layout_phpcms.php
 * refined the update-notifier to show not the 'update available' if no
   connection possible (same file)
 * added the 'reload.gif' to the /parser/gif directory
 * cleaned up the template-directory and changed the PROJECT-fields in the
   documentation and help-files (task 68204)
 * refined the /parser/help/start1.html to look a bit more professional
   (text-font to non-serif and so on)

Jan 09 2003 (e157m369)
 * reformated all the code (all but http-indexer-files) in the
   include-directory
 * improved the GUI in class.options_phpcms.php
    - completely rewrote the function WriteChanges()
    - added the versions-converter to function konfiguration()
    - reorganised the order of showing the input-fields and added some more
      fields (error404, password, etc.) in function konfiguration()

Dec 29 2002 (e157m369)
 * Patch included: Parameters for PAX Dyna-Tags (task #66678)
 * Patch included for improved TOC and MENU (.AKTIV and .SELF)
 * reformated code and split the class.parser_phpcms.php to the 5
   class.parser_*.php-files

Dec 23 2002 (e157m369)
 * fixed bug with linebreak in PAXMAILCRYPT noscript-part

Dec 16 2002 (wulmer)
 * reformatted demo html pages and templates according to XHTML 1.0

Dec 06 2002 (oarsman)
 * deleted ";" at the end of lines in demo-home.mnu

Dec 06 2002 (oarsman)
 * added the missing files: help.ini help.tpl help_en.ini help_en.tpl
   in the parser/template directory

Dec 05 2002 (bjmg)
 * changed the version number to 1.1.10 CVS

Nov 19 2002 (ignatius0815)
 * removed urlencode() and urldecode() callings from
   parser/include/class.edit_phpcms.php

Nov 18 2002 (ignatius0815)
 * cleand up the contents of the .htaccess files
 * created missing .htaccess file in /parser/template

Nov 16 2002 (ignatius0815)
 * fixed bug: [638943] Bug in PHPCMS_INCLUDE RegularExpression

Nov 15 2002 (ignatius0815)
 * fixed bug: [632940] Wrong link to phpCMS homepage in GUI

Nov 14 2002 (ignatius0815)
 * fixed bug: [638099] Bug in session-data handling in 1.1.9
 * fixed bug: [638476] Problem in onlineeditor when cookies off

Nov 13 2002 (ignatius0815)
 * fixed bug: [633964] Online-Editor adds {tags} field
 * fixed bug: [633975] Problems whith missing fields in content
 * fixed bug: [633969] Editor: problems with quotation marks
 * fixed bug: [633961] local links don't work in non-stealth mode
 * fixed bug: [635014] Missing space in multi-line tags
 * fixed bug: [634993] Missing target="_blank" in GUI Logo-Link
 * added feature: 'EDITPASSWORD' in project files can handle now several
   comma seperated passwords, for example
   EDITPASSWORD := admin, password1, password2
 * sexurity fix: in the online-editor passwords are now encrypted before
   the get saved in a cookie
 * fixed bug: "edit"-button now gets suppressed when user is already in
   edit-mode and "view"-button gets suppressed in view-mode
